Subject: bug#14297: 24.3.50; emacs subprocesses don't exit on "exit"

From: Eli Zaretskii <[email-masked]>
Date: Mon, 13 May 2013 20:41:34 +0300

> Date: Mon, 13 May 2013 09:58:17 -0700
> From: Paul Eggert <[email-masked]>
> CC: [email-masked], [email-masked]
> 
> On 05/13/13 08:59, Eli Zaretskii wrote:
> > So I'm not sure this is the same problem.
> 
> I agree.  I brought up the issue because the question
> arose as to how (process-live-p proc) is connected to
> the window toolkit.
> 
> It's conceivable, for example, that a buggy Gtk plugin
> is doing a waitpid (-1, ...), which would mess up
> Emacs greatly (and would also mess up other applications,
> the symptoms observed here).
> 
> Perhaps we should apply something like the following patch,
> to help detect these situations better?

Will calling emacs_abort give us enough information about who's the
culprit?

How about this alternative idea: write a replacement waitpid, which
will check if it is called by someone other than our main thread, and
with its first argument negative, and then produce a backtrace or some
message to stderr?  Would that work to trap calls to waitpid from GTK?